<?php

/**
-------------------------------------------------------------------------
mediamallfactory - Media Mall Factory 4.2.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

class MediaMallFactoryBackendControllerNotification extends JControllerLegacy
{
    public function __construct($config = array())
    {
        parent::__construct($config);

        $this->registerTask('apply', 'save');
        $this->registerTask('save2new', 'save');
    }

    public function save()
    {
        JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

        $app = JFactory::getApplication();
        $data = JFactory::getApplication()->input->post->get('notification', array(), 'array');
        $model = $this->getModel('Notification');
        $option = FactoryApplication::getInstance()->getOption();
        $context = $option . '.edit.notification.data';
        $id = JFactory::getApplication()->input->get->getInt('id', 0);

        $app->setUserState($context, null);
        $data['id'] = $id;

        if ($model->save($data)) {
            $msg = FactoryText::_('notification_save_success');
        } else {
            $msg = FactoryText::_('notification_save_error');

            $app->setUserState($context, $data);

            foreach ($model->getErrors() as $error) {
                $app->enqueueMessage($error, 'error');
            }

            $id = $id ? '&id=' . $id : '';
            $this->setRedirect(FactoryRoute::view('notification' . $id), $msg);

            return false;
        }

        $redirect = FactoryRoute::view('notifications');

        if ('apply' == $this->getTask()) {
            $redirect = FactoryRoute::view('notification&id=' . $model->getState('id'));
        } else if ('save2new' == $this->getTask()) {
            $redirect = FactoryRoute::view('notification');
        }

        $this->setRedirect($redirect, $msg);

        return true;
    }

    public function cancel()
    {
        $this->setRedirect(FactoryRoute::view('notifications'));
    }

    public function add()
    {
        $this->setRedirect(FactoryRoute::view('notification'));
    }

    public function edit()
    {
        $cid = JFactory::getApplication()->input->post->get('cid', array(), 'array');
        $id = isset($cid[0]) ? $cid[0] : 0;

        $this->setRedirect(FactoryRoute::view('notification&id=' . $id));
    }

    public function refresh()
    {
        JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

        $app = JFactory::getApplication();
        $data = JFactory::getApplication()->input->post->get('notification', array(), 'array');
        $option = FactoryApplication::getInstance()->getOption();
        $context = $option . '.edit.notification.data';
        $id = JFactory::getApplication()->input->get->getInt('id', 0);

        $app->setUserState($context, $data);

        $id = $id ? '&id=' . $id : '';
        $this->setRedirect(FactoryRoute::view('notification' . $id));

        return true;
    }
}
