<?php

/**
-------------------------------------------------------------------------
mediamallfactory - Media Mall Factory 4.2.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

JLoader::register('BlogFactoryDataProviderInterface', JPATH_SITE . '/components/com_blogfactory/helpers/dataprovider.php');
JLoader::register('BlogFactoryDataProvider', JPATH_SITE . '/components/com_blogfactory/helpers/dataprovider.php');

class MediaMallFactoryBlogFactoryDataProvider extends BlogFactoryDataProvider implements BlogFactoryDataProviderInterface
{
    public function getItems($userId, $limit = 0, $limitstart = 0, $search = null)
    {
        // Initialise variables.
        $dbo = $this->getDbo();
        $items = array();
        $settings = JComponentHelper::getParams('com_mediamallfactory');
        $width = $settings->get('general.thumbnails.small_media_width', 64);

        // Get items.
        $query = $dbo->getQuery(true)
            ->select('m.id, m.title, m.description, m.category_id, m.filename_thumbnail, m.user_id')
            ->from('#__mediamallfactory_media m')
            ->where('m.user_id = ' . $dbo->quote($userId))
            ->order('m.title ASC');

        if (!is_null($search)) {
            $query->where('m.title LIKE ' . $dbo->quote('%' . $search . '%'));
        }

        $query->select('c.title AS category_title')
            ->leftJoin('#__categories c ON c.id = m.category_id');

        $results = $dbo->setQuery($query, $limitstart, $limit)
            ->loadObjectList();

        // Parse items.
        foreach ($results as $result) {
            $items[] = (object)array(
                'title'       => $result->title,
                'description' => $result->description,
                'link'        => JRoute::_('index.php?option=com_mediamallfactory&view=media&media_id=' . $result->id, false),
                'photos'      => array(
                    JURI::root() . 'components/com_mediamallfactory/storage/' . $result->user_id . '/thumbnails/' . $this->getThumbnailSrc($result->filename_thumbnail, $width),
                ),

                'extra' => array(
                    JText::_('JCATEGORY') => '<a href="' . JRoute::_('index.php?option=com_mediamallfactory&view=categories&category_id=' . $result->category_id) . '">' . $result->category_title . '</a>',
                ),
            );
        }

        return $items;
    }

    public function getTotal($userId, $search = null)
    {
        // Initialise variables.
        $dbo = $this->getDbo();

        // Get query.
        $query = $dbo->getQuery(true)
            ->select('COUNT(m.id) AS total')
            ->from('#__mediamallfactory_media m')
            ->where('m.user_id = ' . $dbo->quote($userId));

        if (!is_null($search)) {
            $query->where('m.title LIKE ' . $dbo->quote('%' . $search . '%'));
        }

        $result = $dbo->setQuery($query)
            ->loadResult();

        return $result;
    }

    protected function getThumbnailSrc($thumbnail, $width)
    {
        jimport('joomla.filesystem.file');

        $name = JFile::stripExt($thumbnail);
        $ext = JFile::getExt($thumbnail);

        return $name . '_' . $width . '.' . $ext;
    }
}
