<?php

/**
-------------------------------------------------------------------------
mediamallfactory - Media Mall Factory 4.2.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

defined('DS') or define('DS', DIRECTORY_SEPARATOR);

class plgContentMediaMallFactory extends JPlugin
{
    public function onContentAfterSave($context, &$article, $isNew)
    {
        jimport('joomla.filesystem.folder');
        jimport('joomla.filesystem.file');

        // Check if we're saving a category.
        if ($context != 'com_categories.category') {
            return true;
        }

        // Check if we're saving a Media Mall Factory category.
        if (!isset($article->extension) || 'com_mediamallfactory' != $article->extension) {
            return true;
        }

        // Get the category params.
        $params = new JRegistry($article->params);

        // Check if we're adding a new thumbnail.
        if ('' == $params->get('thumbnail.new', '')) {
            return true;
        }

        // Remove old thumbnail.
        if ('' != $params->get('thumbnail.current', '')) {
            $src = JPATH_SITE . DS . 'components' . DS . 'com_mediamallfactory' . DS . 'storage' . DS . 'thumbnails' . DS . $params->get('thumbnail.current', '');

            if (JFile::exists($src)) {
                JFile::delete($src);
            }
        }

        JLoader::register('SimpleImage', JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_mediamallfactory' . DS . 'libraries' . DS . 'resize.php');
        $src = JPATH_SITE . DS . $params->get('thumbnail.new', '');
        $dest = JPATH_SITE . DS . 'components' . DS . 'com_mediamallfactory' . DS . 'storage' . DS . 'thumbnails';
        $ext = JFile::getExt($params->get('thumbnail.new', ''));
        $filename = $article->id . '.' . $ext;

        if (!JFolder::exists($dest)) {
            JFolder::create($dest);
        }

        $settings = JComponentHelper::getParams('com_mediamallfactory');

        SimpleImage::getInstance()
            ->load($src)
            ->resizeToWidth($settings->get('general.thumbnails.category_width', 64))
            ->save($dest . DS . $filename, IMAGETYPE_JPEG, $settings->get('general.thumbnails.quality', 80));

        $params->set('thumbnail.current', $filename);
        $params->set('thumbnail.new', '');
        $article->params = $params->toString();

        $article->store();

        return true;
    }
}
